import './style.css';
import { withDirectives as A, openBlock as g, createElementBlock as p, vModelText as Q, createCommentVNode as h, resolveComponent as X, resolveDirective as Y, normalizeClass as S, normalizeStyle as M, createElementVNode as C, createBlock as N, resolveDynamicComponent as Z, withCtx as P, renderSlot as v, toDisplayString as R, vShow as K, mergeProps as _, withKeys as $, Fragment as x, renderList as ee } from "vue";
import te from "vuedraggable";
const z = (e, t) => {
  const s = e.__vccOpts || e;
  for (const [i, r] of t)
    s[i] = r;
  return s;
}, se = {
  name: "TagInput",
  props: {
    scope: {
      type: Object
    }
  }
}, ie = ["maxlength"];
function ae(e, t, s, i, r, u) {
  return s.scope.edit ? A((g(), p("input", {
    key: 0,
    "onUpdate:modelValue": t[0] || (t[0] = (l) => s.scope.element.text = l),
    maxlength: s.scope.maxlength,
    type: "text",
    class: "ti-tag-input",
    size: "1",
    onInput: t[1] || (t[1] = (l) => s.scope.validateTag(s.scope.index, l)),
    onBlur: t[2] || (t[2] = (l) => s.scope.cancelEditOnBlurInput ? s.scope.performCancelEdit(s.scope.index) : null),
    onKeydown: t[3] || (t[3] = (l) => s.scope.performSaveEdit(s.scope.index, l))
  }, null, 40, ie)), [
    [Q, s.scope.element.text]
  ]) : h("", !0);
}
const ne = /* @__PURE__ */ z(se, [["render", ae], ["__scopeId", "data-v-e2fc0952"]]), q = (e) => !e.some((t) => {
  const s = !t.text;
  s && console.warn('Missing property "text"', t);
  let i = !1;
  return t.classes && (i = typeof t.classes != "string"), i && console.warn('Property "classes" must be type of string', t), s || i;
}), L = (e) => !e.some((t) => {
  if (typeof t == "number") {
    const s = isFinite(t) && Math.floor(t) === t;
    return s || console.warn("Only numerics are allowed for this prop. Found:", t), !s;
  } else if (typeof t == "string") {
    const s = /\W|[a-z]|!\d/i.test(t);
    return s || console.warn("Only alpha strings are allowed for this prop. Found:", t), !s;
  } else
    return console.warn("Only numeric and string values are allowed. Found:", t), !1;
}), re = {
  /**
   * @description Property to bind a model to the input.
     If the user changes the input value, the model updates, too.
     If the user presses enter with an valid input,
     a new tag is created with the value of this model.
     After creating the new tag, the model is cleared.
   * @property {props}
   * @required
   * @type {String}
   * @model
   * @default ''
   */
  modelValue: {
    type: String,
    default: "",
    required: !0
  },
  /**
   * @description Pass an array containing objects like in the example below.
     The properties 'style' and 'class' are optional. Of course it is possible to add custom
     properties to a tag object. vue-tags-input won't change the key and value.
   * @property {props}
   * @type {Array}
   * @sync
   * @default []
   * @example
    {
    &emsp;text: 'My tag value', &#47;* The visible text on display *&#47;
    &emsp;style: 'background-color: #ccc', &#47;* Adding inline styles is possible *&#47;
    &emsp;classes: 'custom-class another', &#47;* The value will be added as css classes *&#47;
    }
   */
  tags: {
    type: Array,
    default: () => [],
    validator: q
  },
  /**
   * @description Expects an array containing objects inside. The objects
    can have the same properties as a tag object.
   * @property {props}
   * @type {Array}
   * @default []
   */
  autocompleteItems: {
    type: Array,
    default: () => [],
    validator: q
  },
  /**
   * @description Defines whether a tag is editable after creation or not.
   * @property {props}
   * @type {Boolean}
   * @default false
   */
  allowEditTags: {
    type: Boolean,
    default: !1
  },
  /**
   * @description Defines if duplicate autocomplete items are filtered out from the view or not.
   * @property {props}
   * @type {Boolean}
   * @default true
   */
  autocompleteFilterDuplicates: {
    default: !0,
    type: Boolean
  },
  /**
   * @description If it's true, the user can add tags only via the autocomplete layer.
   * @property {props}
   * @type {Boolean}
   * @default false
   */
  addOnlyFromAutocomplete: {
    type: Boolean,
    default: !1
  },
  /**
   * @description The minimum character length which is required
     until the autocomplete layer is shown. If set to 0,
     then it'll be shown on focus.
   * @property {props}
   * @type {Number}
   * @default 1
   */
  autocompleteMinLength: {
    type: Number,
    default: 1
  },
  /**
   * @description If it's true, the autocomplete layer is always shown, regardless if
     an input or an autocomplete items exists.
   * @property {props}
   * @type {Boolean}
   * @default false
   */
  autocompleteAlwaysOpen: {
    type: Boolean,
    default: !1
  },
  /**
   * @description Property to disable vue-tags-input.
   * @property {props}
   * @type {Boolean}
   * @default false
   */
  disabled: {
    type: Boolean,
    default: !1
  },
  /**
   * @description The placeholder text which is shown in the input, when it's empty.
   * @property {props}
   * @type {String}
   * @default Add Tag
   */
  placeholder: {
    type: String,
    default: "Add Tag"
  },
  /**
   * @description Custom trigger key codes can be registrated. If the user presses one of these,
     a tag will be generated out of the input value. Can be either a numeric keyCode or the key
     as a string.
   * @property {props}
   * @type {Array}
   * @default [13]
   * @example add-on-key="[13, ':', ';']"
   */
  addOnKey: {
    type: Array,
    default: () => [13],
    validator: L
  },
  /**
   * @description Custom trigger key codes can be registrated. If the user edits a tag
     and presses one of these, the edited tag will be saved.
     Can be either a numeric keyCode or the key as a string.
   * @property {props}
   * @type {Array}
   * @default [13]
   * @example save-on-key="[13, ':', ';']"
   */
  saveOnKey: {
    type: Array,
    default: () => [13],
    validator: L
  },
  /**
   * @description The maximum amount the tags array is allowed to hold.
   * @property {props}
   * @type {Number}
   */
  maxTags: {
    type: Number
  },
  /**
   * @description The maximum amount of characters the input is allowed to hold.
   * @property {props}
   * @type {Number}
   */
  maxlength: {
    type: Number
  },
  /**
   * @description Pass an array containing objects like in the example below.
     The property 'classes' will be added as css classes, if the property 'rule' matches the text
     of a tag, an autocomplete item or the input. The property 'rule' can be type of
     RegExp or function. If the property 'disableAdd' is 'true', the item can't be added
     to the tags array, if the appropriated rule matches.
   * @property {props}
   * @type {Array}
   * @default []
   * @example
    {
    &ensp;classes: 'class', &#47;* css class *&#47;
    &ensp;rule: /^([^0-9]*)$/, &#47;* RegExp *&#47;
    }, {
    &ensp;classes: 'no-braces', &#47;* css class *&#47;
    &ensp;rule(text) { &#47;* function with text as param *&#47;
    &ensp;&ensp;return text.indexOf('{') !== -1 || text.indexOf('}') !== -1;
    &ensp;},
    &ensp;disableAdd: true, &#47;* if the rule matches, the item cannot be added *&#47;,
    },
   */
  validation: {
    type: Array,
    default: () => [],
    validator(e) {
      return !e.some((t) => {
        const s = !t.rule;
        s && console.warn('Property "rule" is missing', t);
        const i = t.rule && (typeof t.rule == "string" || t.rule instanceof RegExp || {}.toString.call(t.rule) === "[object Function]");
        i || console.warn(
          "A rule must be type of string, RegExp or function. Found:",
          JSON.stringify(t.rule)
        );
        const r = !t.classes;
        r && console.warn('Property "classes" is missing', t);
        const u = t.type && typeof t.type != "string";
        return u && console.warn('Property "type" must be type of string. Found:', t), !i || s || r || u;
      });
    }
  },
  /**
   * @description Defines the characters which splits a text into different pieces,
     to generate tags out of this pieces.
   * @property {props}
   * @type {Array}
   * @default [';']
   * @example
     separators: [';', ',']
     input: some; user input, has random; commas, an,d semicolons
     will split into: some - user input - has random - commas - an - d semicolons
   */
  separators: {
    type: Array,
    default: () => [";"],
    validator(e) {
      return !e.some((t) => {
        const s = typeof t != "string";
        return s && console.warn("Separators must be type of string. Found:", t), s;
      });
    }
  },
  /**
   * @description If it's true, the user can't add or save a tag,
     if another exists, with the same text value.
   * @property {props}
   * @type {Boolean}
   * @default true
   */
  avoidAddingDuplicates: {
    type: Boolean,
    default: !0
  },
  /**
   * @description If the input holds a value and loses the focus,
     a tag will be generated out of this value, if possible.
   * @property {props}
   * @type {Boolean}
   * @default true
   */
  addOnBlur: {
    type: Boolean,
    default: !0
  },
  /**
   * @description Custom function to detect duplicates. If the function returns 'true',
    the tag will be marked as duplicate.
   * @property {props}
   * @type {Function}
   * @param {Array} tagsarray The Array of tags minus the one which is edited/created.
   * @param {Object} tag The tag which is edited or should be added to the tags array.
   * @example
     // The duplicate function to recreate the default behaviour, would look like this:
     isDuplicate(tags, tag) {
     &ensp;return tags.map(t => t.text).indexOf(tag.text) !== -1;
    }
   */
  isDuplicate: {
    type: Function,
    default: null
  },
  /**
   * @description If it's true, the user can paste into the input element and
     vue-tags-input will create tags out of the incoming text.
   * @property {props}
   * @type {Boolean}
   * @default true
   */
  addFromPaste: {
    type: Boolean,
    default: !0
  },
  /**
   * @description Defines if it's possible to delete tags by pressing backspace.
     If so and the user wants to delete a tag,
     the tag gets the css class 'deletion-mark' for 1 second.
     If the user presses backspace again in that time period,
     the tag is removed from the tags array and the view.
   * @property {props}
   * @type {Boolean}
   * @default true
   */
  deleteOnBackspace: {
    default: !0,
    type: Boolean
  },
  /**
   * @description Defines if it's possible to reorder items using drag and drop.
   * @property {props}
   * @type {Boolean}
   * @default false
   */
  isDraggable: {
    type: Boolean,
    default: !1
  },
  /**
   * @description Defines if items use handle to be dragged.
   * @property {props}
   * @type {Boolean}
   * @default false
   */
  draggableHandle: {
    type: Boolean,
    default: !1
  },
  /**
   * @description Defines draggable group.
   * @property {props}
   * @type {String, Object}
   * @default 'tags'
   */
  draggableGroup: {
    type: [String, Object],
    default: "tags"
  },
  /**
   * @description Defines draggable animation.
   * @property {props}
   * @type {Number}
   * @default 200
   */
  draggableAnimation: {
    type: Number,
    default: 200
  },
  cancelEditOnBlurInput: {
    type: Boolean,
    default: !1
  },
  cancelEditOnBlurWrapper: {
    type: Boolean,
    default: !0
  },
  // event handlers
  onBeforeAddingTag: Function,
  onBeforeDeletingTag: Function,
  onBeforeEditingTag: Function,
  onBeforeSavingTag: Function
};
var oe = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function J(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var le = function e(t, s) {
  if (t === s)
    return !0;
  if (t && s && typeof t == "object" && typeof s == "object") {
    if (t.constructor !== s.constructor)
      return !1;
    var i, r, u;
    if (Array.isArray(t)) {
      if (i = t.length, i != s.length)
        return !1;
      for (r = i; r-- !== 0; )
        if (!e(t[r], s[r]))
          return !1;
      return !0;
    }
    if (t.constructor === RegExp)
      return t.source === s.source && t.flags === s.flags;
    if (t.valueOf !== Object.prototype.valueOf)
      return t.valueOf() === s.valueOf();
    if (t.toString !== Object.prototype.toString)
      return t.toString() === s.toString();
    if (u = Object.keys(t), i = u.length, i !== Object.keys(s).length)
      return !1;
    for (r = i; r-- !== 0; )
      if (!Object.prototype.hasOwnProperty.call(s, u[r]))
        return !1;
    for (r = i; r-- !== 0; ) {
      var l = u[r];
      if (!e(t[l], s[l]))
        return !1;
    }
    return !0;
  }
  return t !== t && s !== s;
};
const de = /* @__PURE__ */ J(le), ue = (e, t) => t.filter((s) => {
  const { text: i } = e;
  if (typeof s.rule == "string")
    return !new RegExp(s.rule).test(i);
  if (s.rule instanceof RegExp)
    return !s.rule.test(i);
  if ({}.toString.call(s.rule) === "[object Function]")
    return s.rule(e);
}).map((s) => s.classes), w = (e) => JSON.parse(JSON.stringify(e)), ge = (e, t) => {
  let s = 0;
  for (; s < e.length; ) {
    if (t(e[s], s, e))
      return s;
    s++;
  }
  return -1;
}, U = (e, t, s = [], i) => {
  e.text === void 0 && (e = { text: e });
  const r = ue(e, s), u = ge(t, (n) => n === e), l = w(t), T = u !== -1 ? l.splice(u, 1)[0] : w(e);
  return (i ? i(l, T) : l.map((n) => n.text).indexOf(T.text) !== -1) && r.push("ti-duplicate"), r.length === 0 ? r.push("ti-valid") : r.push("ti-invalid"), r;
}, b = (e, ...t) => {
  e.text === void 0 && (e = { text: e });
  const s = w(e);
  return s.tiClasses = U(e, ...t), s;
}, pe = (e, ...t) => e.map((s) => b(s, e, ...t));
var G = { exports: {} };
(function(e, t) {
  (function(s, i) {
    e.exports = i();
  })(oe, function() {
    var s = "__v-click-outside", i = typeof window < "u", r = typeof navigator < "u", u = i && ("ontouchstart" in window || r && navigator.msMaxTouchPoints > 0) ? ["touchstart"] : ["click"], l = function(o) {
      var f = o.event, c = o.handler;
      (0, o.middleware)(f) && c(f);
    }, T = function(o, f) {
      var c = function(d) {
        var m = typeof d == "function";
        if (!m && typeof d != "object")
          throw new Error("v-click-outside: Binding value must be a function or an object");
        return { handler: m ? d : d.handler, middleware: d.middleware || function(y) {
          return y;
        }, events: d.events || u, isActive: d.isActive !== !1, detectIframe: d.detectIframe !== !1, capture: !!d.capture };
      }(f.value), I = c.handler, V = c.middleware, H = c.detectIframe, B = c.capture;
      if (c.isActive) {
        if (o[s] = c.events.map(function(d) {
          return { event: d, srcTarget: document.documentElement, handler: function(m) {
            return function(y) {
              var k = y.el, E = y.event, F = y.handler, O = y.middleware, j = E.path || E.composedPath && E.composedPath();
              (j ? j.indexOf(k) < 0 : !k.contains(E.target)) && l({ event: E, handler: F, middleware: O });
            }({ el: o, event: m, handler: I, middleware: V });
          }, capture: B };
        }), H) {
          var W = { event: "blur", srcTarget: window, handler: function(d) {
            return function(m) {
              var y = m.el, k = m.event, E = m.handler, F = m.middleware;
              setTimeout(function() {
                var O = document.activeElement;
                O && O.tagName === "IFRAME" && !y.contains(O) && l({ event: k, handler: E, middleware: F });
              }, 0);
            }({ el: o, event: d, handler: I, middleware: V });
          }, capture: B };
          o[s] = [].concat(o[s], [W]);
        }
        o[s].forEach(function(d) {
          var m = d.event, y = d.srcTarget, k = d.handler;
          return setTimeout(function() {
            o[s] && y.addEventListener(m, k, B);
          }, 0);
        });
      }
    }, a = function(o) {
      (o[s] || []).forEach(function(f) {
        return f.srcTarget.removeEventListener(f.event, f.handler, f.capture);
      }), delete o[s];
    }, n = i ? { beforeMount: T, updated: function(o, f) {
      var c = f.value, I = f.oldValue;
      JSON.stringify(c) !== JSON.stringify(I) && (a(o), T(o, { value: c }));
    }, unmounted: a } : {};
    return { install: function(o) {
      o.directive("click-outside", n);
    }, directive: n };
  });
})(G);
var fe = G.exports;
const ce = /* @__PURE__ */ J(fe), me = {
  name: "VueTagsInput",
  components: { TagInput: ne, draggable: te },
  props: re,
  directives: {
    clickOutside: ce.directive
  },
  emits: [
    "adding-duplicate",
    "before-adding-tag",
    "before-deleting-tag",
    "before-editing-tag",
    "before-saving-tag",
    "max-tags-reached",
    "saving-duplicate",
    "tags-changed",
    "tag-clicked",
    "update:modelValue",
    "update:tags",
    "tag-order-changed",
    "click"
  ],
  inheritAttrs: !1,
  data() {
    return {
      tagCenter: [],
      newTag: null,
      tagsCopy: [],
      tagsEditStatus: null,
      deletionMark: null,
      deletionMarkTime: null,
      selectedItem: null,
      focused: null
    };
  },
  computed: {
    // Property which calculates if the autocomplete should be opened or not
    autocompleteOpen() {
      return this.autocompleteAlwaysOpen ? !0 : this.newTag !== null && this.newTag.length >= this.autocompleteMinLength && this.filteredAutocompleteItems.length > 0 && this.focused;
    },
    // Returns validated autocomplete items. Maybe duplicates are filtered out
    filteredAutocompleteItems() {
      const e = this.autocompleteItems.map((t) => b(t, this.tags, this.validation, this.isDuplicate));
      return this.autocompleteFilterDuplicates ? e.filter(this.duplicateFilter) : e;
    }
  },
  methods: {
    onClickOutsideVueTagInput(e) {
      if (this.cancelEditOnBlurWrapper)
        for (let t = 0; t <= this.tagsEditStatus.length; t++)
          this.tagsEditStatus[t] && this.cancelEdit(t);
    },
    createClasses: U,
    // Returns the index which item should be selected, based on the parameter 'method'
    getSelectedIndex(e) {
      const t = this.filteredAutocompleteItems, s = this.selectedItem, i = t.length - 1;
      if (t.length !== 0)
        return s === null ? 0 : e === "before" && s === 0 ? i : e === "after" && s === i ? 0 : e === "after" ? s + 1 : s - 1;
    },
    selectDefaultItem() {
      this.addOnlyFromAutocomplete && this.filteredAutocompleteItems.length > 0 ? this.selectedItem = 0 : this.selectedItem = null;
    },
    selectItem(e, t) {
      e.preventDefault(), this.selectedItem = this.getSelectedIndex(t);
    },
    isSelected(e) {
      return this.selectedItem === e;
    },
    isMarked(e) {
      return this.deletionMark === e;
    },
    // Save ref for tag
    setTagCenter(e) {
      e && this.tagCenter.push(e);
    },
    // Method which is called when the user presses backspace → remove the last tag
    invokeDelete() {
      if (!this.deleteOnBackspace || this.newTag.length > 0)
        return;
      const e = this.tagsCopy.length - 1;
      this.deletionMark === null ? (this.deletionMarkTime = setTimeout(() => this.deletionMark = null, 1e3), this.deletionMark = e) : this.performDeleteTag(e);
    },
    addTagsFromPaste() {
      this.addFromPaste && setTimeout(() => this.performAddTags(this.newTag), 10);
    },
    // Method to call if a tag should switch to it's edit mode
    performEditTag(e) {
      this.allowEditTags && (this.onBeforeAddingTag || this.editTag(e), this.$emit("before-editing-tag", {
        index: e,
        tag: this.tagsCopy[e],
        editTag: () => this.editTag(e)
      }));
    },
    // Opens the edit mode for a tag and focuses it
    editTag(e) {
      this.allowEditTags && (this.toggleEditMode(e), this.focus(e));
    },
    // Toggles the edit mode for a tag
    toggleEditMode(e) {
      !this.allowEditTags || this.disabled || (this.tagsEditStatus[e] = !this.tagsEditStatus[e]);
    },
    // only called by the @input event from TagInput.
    // Creates a new tag model and applys it to this.tagsCopy[index]
    createChangedTag(e, t) {
      const s = this.tagsCopy[e];
      s.text = t ? t.target.value : this.tagsCopy[e].text, this.tagsCopy[e] = b(s, this.tagsCopy, this.validation, this.isDuplicate);
    },
    // Focuses the input of a tag
    focus(e) {
      this.$nextTick(() => {
        const t = this.tagCenter[e].querySelector("input.ti-tag-input");
        t && t.focus();
      });
    },
    quote(e) {
      return e.replace(/([()[{*+.$^\\|?])/g, "\\$1");
    },
    // Cancels the edit mode for a tag → resets the tag to it's original model!
    cancelEdit(e) {
      this.tags[e] && (this.tagsCopy[e] = w(
        b(this.tags[e], this.tags, this.validation, this.isDuplicate)
      ), this.tagsEditStatus[e] = !1);
    },
    hasForbiddingAddRule(e) {
      return e.some((t) => {
        const s = this.validation.find((i) => t === i.classes);
        return s ? s.disableAdd : !1;
      });
    },
    // Creates multiple tags out of a string, based on the prop separators
    createTagTexts(e) {
      const t = new RegExp(this.separators.map((s) => this.quote(s)).join("|"));
      return e.split(t).map((s) => ({ text: s }));
    },
    // Method to call to delete a tag
    performDeleteTag(e) {
      this.onBeforeDeletingTag || this.deleteTag(e), this.$emit("before-deleting-tag", {
        index: e,
        tag: this.tagsCopy[e],
        deleteTag: () => this.deleteTag(e)
      });
    },
    deleteTag(e) {
      this.disabled || (this.deletionMark = null, clearTimeout(this.deletionMarkTime), this.tagsCopy.splice(e, 1), this.$emit("update:tags", this.tagsCopy), this.$emit("tags-changed", this.tagsCopy));
    },
    // Decides wether the input keyCode is one, which is allowed to modify/add tags
    noTriggerKey(e, t) {
      const s = this[t].indexOf(e.keyCode) !== -1 || this[t].indexOf(e.key) !== -1;
      return s && e.preventDefault(), !s;
    },
    // Method to call to add a tag
    performAddTags(e, t, s) {
      if (this.disabled || t && this.noTriggerKey(t, "addOnKey"))
        return;
      let i = [];
      typeof e == "object" && (i = [e]), typeof e == "string" && (i = this.createTagTexts(e)), i = i.filter((r) => r.text.trim().length > 0), i.forEach((r) => {
        r = b(r, this.tags, this.validation, this.isDuplicate), this.onBeforeAddingTag || this.addTag(r, s), this.$emit("before-adding-tag", {
          tag: r,
          addTag: () => this.addTag(r, s)
        });
      });
    },
    duplicateFilter(e) {
      return this.isDuplicate ? !this.isDuplicate(this.tagsCopy, e) : !this.tagsCopy.find((t) => t.text === e.text);
    },
    addTag(e, t = "new-tag-input") {
      const s = this.filteredAutocompleteItems.map((i) => i.text);
      this.addOnlyFromAutocomplete && s.indexOf(e.text) === -1 || this.$nextTick(() => {
        if (this.maxTags && this.maxTags <= this.tagsCopy.length)
          return this.$emit("max-tags-reached", e);
        if (this.avoidAddingDuplicates && !this.duplicateFilter(e))
          return this.$emit("adding-duplicate", e);
        this.hasForbiddingAddRule(e.tiClasses) || (this.newTag = "", this.tagsCopy.push(e), this.$emit("update:tags", this.tagsCopy), t === "autocomplete" && this.$refs.newTagInput.focus(), this.$emit("tags-changed", this.tagsCopy));
      });
    },
    // Method to call to save a tag
    performSaveTag(e, t) {
      const s = this.tagsCopy[e];
      this.disabled || t && this.noTriggerKey(t, "addOnKey") || s.text.trim().length !== 0 && (this["on-before-saving-tag"] || this.saveTag(e, s), this.$emit("before-saving-tag", {
        index: e,
        tag: s,
        saveTag: () => this.saveTag(e, s)
      }));
    },
    saveTag(e, t) {
      if (this.avoidAddingDuplicates) {
        const s = w(this.tagsCopy), i = s.splice(e, 1)[0];
        if (this.isDuplicate ? this.isDuplicate(s, i) : s.map((u) => u.text).indexOf(i.text) !== -1)
          return this.$emit("saving-duplicate", t);
      }
      this.hasForbiddingAddRule(t.tiClasses) || (this.tagsCopy[e] = t, this.toggleEditMode(e), this.$emit("update:tags", this.tagsCopy), this.$emit("tags-changed", this.tagsCopy));
    },
    tagsEqual() {
      return !this.tagsCopy.some((e, t) => !de(e, this.tags[t]));
    },
    updateNewTag(e) {
      const t = e.target.value;
      this.newTag = t, this.$emit("update:modelValue", t);
    },
    initTags() {
      this.tagsCopy = pe(this.tags, this.validation, this.isDuplicate), this.tagsEditStatus = w(this.tags).map(() => !1), this.tagsEqual() || this.$emit("update:tags", this.tagsCopy);
    },
    blurredOnClick(e) {
      this.$el.contains(e.target) || this.$el.contains(document.activeElement) || this.performBlur(e);
    },
    performBlur() {
      this.addOnBlur && this.focused && this.performAddTags(this.newTag), this.focused = !1;
    },
    tagOrderChanged() {
      this.$emit("tag-order-changed", this.tagsCopy);
    },
    performClick(e) {
      if (this.addOnlyFromAutocomplete)
        return this.$emit("click", e), !1;
      this.selectedItem = null, this.$emit("click", e);
    },
    getTagIndex(e) {
      return this.tagsCopy.findIndex((t) => t.text === e.text);
    }
  },
  watch: {
    modelValue(e) {
      this.addOnlyFromAutocomplete || (this.selectedItem = null), this.newTag = e;
    },
    tags: {
      handler() {
        this.initTags();
      },
      deep: !0
    },
    autocompleteOpen: "selectDefaultItem"
  },
  created() {
    this.newTag = this.modelValue, this.initTags();
  },
  mounted() {
    this.selectDefaultItem(), document.addEventListener("click", this.blurredOnClick);
  },
  beforeUpdate() {
    this.tagCenter = [];
  },
  unmounted() {
    document.removeEventListener("click", this.blurredOnClick);
  }
};
const he = { class: "ti-input" }, ye = ["onClick"], ve = { class: "ti-content" }, Te = {
  key: 0,
  class: "handle"
}, Ee = {
  key: 1,
  class: "ti-tag-left"
}, Ce = ["onClick"], ke = {
  key: 2,
  class: "ti-tag-right"
}, we = { class: "ti-actions" }, Oe = ["onClick"], be = ["onClick"], Ie = { class: "ti-new-tag-input-wrapper" }, Se = ["placeholder", "value", "maxlength", "disabled"], $e = ["onMouseover"], Ae = ["onClick"];
function De(e, t, s, i, r, u) {
  const l = X("tag-input"), T = Y("click-outside");
  return g(), p("div", {
    class: S(["vue-tags-input", [{ "ti-disabled": e.disabled }, { "ti-focus": e.focused }, e.$attrs.class]]),
    style: M(e.$attrs.style)
  }, [
    C("div", he, [
      e.tagsCopy ? A((g(), N(Z(e.isDraggable ? "draggable" : "ul"), {
        key: 0,
        modelValue: e.tagsCopy,
        "onUpdate:modelValue": t[9] || (t[9] = (a) => e.tagsCopy = a),
        group: e.draggableGroup,
        class: "ti-tags",
        tag: "ul",
        draggable: ".item",
        handle: e.draggableHandle ? ".handle" : "",
        "ghost-class": "ghost-tag",
        "drag-class": "drag-tag",
        "item-key": e.getTagIndex,
        animation: e.draggableAnimation,
        onStart: t[10] || (t[10] = (a) => e.drag = !0),
        onEnd: t[11] || (t[11] = (a) => {
          e.drag = !1, e.tagOrderChanged();
        })
      }, {
        item: P(({ element: a, index: n }) => [
          (g(), p("li", {
            key: n + 0,
            style: M(a.style),
            class: S([[
              { "ti-editing": e.tagsEditStatus[n] },
              a.tiClasses,
              a.classes,
              { "ti-deletion-mark": e.isMarked(n) }
            ], "ti-tag item"]),
            tabindex: "0",
            onClick: (o) => e.$emit("tag-clicked", { element: a, index: n })
          }, [
            C("div", ve, [
              e.draggableHandle ? (g(), p("span", Te, "::")) : h("", !0),
              e.$slots["tag-left"] ? (g(), p("div", Ee, [
                v(e.$slots, "tag-left", {
                  tag: a,
                  index: n,
                  edit: e.tagsEditStatus[n],
                  performSaveEdit: e.performSaveTag,
                  performDelete: e.performDeleteTag,
                  performCancelEdit: e.cancelEdit,
                  performOpenEdit: e.performEditTag,
                  deletionMark: e.isMarked(n)
                }, void 0, !0)
              ])) : h("", !0),
              C("div", {
                ref: e.setTagCenter,
                class: "ti-tag-center"
              }, [
                e.$slots["tag-center"] ? h("", !0) : (g(), p("span", {
                  key: 0,
                  class: S({ "ti-hidden": e.tagsEditStatus[n] }),
                  onClick: (o) => e.performEditTag(n)
                }, R(a.text), 11, Ce)),
                e.$slots["tag-center"] ? h("", !0) : (g(), N(l, {
                  key: 1,
                  scope: {
                    edit: e.tagsEditStatus[n],
                    maxlength: e.maxlength,
                    element: a,
                    index: n,
                    validateTag: e.createChangedTag,
                    performCancelEdit: e.cancelEdit,
                    performSaveEdit: e.performSaveTag,
                    cancelEditOnBlurInput: e.cancelEditOnBlurInput
                  }
                }, null, 8, ["scope"])),
                v(e.$slots, "tag-center", {
                  tag: a,
                  index: n,
                  maxlength: e.maxlength,
                  edit: e.tagsEditStatus[n],
                  performSaveEdit: e.performSaveTag,
                  performDelete: e.performDeleteTag,
                  performCancelEdit: e.cancelEdit,
                  validateTag: e.createChangedTag,
                  performOpenEdit: e.performEditTag,
                  deletionMark: e.isMarked(n),
                  cancelEditOnBlurInput: e.cancelEditOnBlurInput
                }, void 0, !0)
              ], 512),
              e.$slots["tag-right"] ? (g(), p("div", ke, [
                v(e.$slots, "tag-right", {
                  tag: a,
                  index: n,
                  edit: e.tagsEditStatus[n],
                  performSaveEdit: e.performSaveTag,
                  performDelete: e.performDeleteTag,
                  performCancelEdit: e.cancelEdit,
                  performOpenEdit: e.performEditTag,
                  deletionMark: e.isMarked(n)
                }, void 0, !0)
              ])) : h("", !0)
            ]),
            C("div", we, [
              e.$slots["tag-actions"] ? h("", !0) : A((g(), p("i", {
                key: 0,
                class: "ti-icon-undo",
                onClick: (o) => e.cancelEdit(n)
              }, null, 8, Oe)), [
                [K, e.tagsEditStatus[n]]
              ]),
              e.$slots["tag-actions"] ? h("", !0) : A((g(), p("i", {
                key: 1,
                class: "ti-icon-close",
                onClick: (o) => e.performDeleteTag(n)
              }, null, 8, be)), [
                [K, !e.tagsEditStatus[n]]
              ]),
              e.$slots["tag-actions"] ? v(e.$slots, "tag-actions", {
                key: 2,
                tag: a,
                index: n,
                edit: e.tagsEditStatus[n],
                performSaveEdit: e.performSaveTag,
                performDelete: e.performDeleteTag,
                performCancelEdit: e.cancelEdit,
                performOpenEdit: e.performEditTag,
                deletionMark: e.isMarked(n)
              }, void 0, !0) : h("", !0)
            ])
          ], 14, ye))
        ]),
        footer: P(() => [
          C("li", Ie, [
            C("input", _({ ref: "newTagInput" }, e.$attrs, {
              class: [[e.createClasses(e.newTag, e.tags, e.validation, e.isDuplicate)], "ti-new-tag-input"],
              placeholder: e.placeholder,
              value: e.newTag,
              maxlength: e.maxlength,
              disabled: e.disabled,
              type: "text",
              size: "1",
              onKeydown: [
                t[0] || (t[0] = (a) => e.performAddTags(
                  e.filteredAutocompleteItems[e.selectedItem] || e.newTag,
                  a
                )),
                t[2] || (t[2] = $((...a) => e.invokeDelete && e.invokeDelete(...a), ["delete"])),
                t[3] || (t[3] = $((...a) => e.performBlur && e.performBlur(...a), ["tab"])),
                t[4] || (t[4] = $((a) => e.selectItem(a, "before"), ["up"])),
                t[5] || (t[5] = $((a) => e.selectItem(a, "after"), ["down"]))
              ],
              onPaste: t[1] || (t[1] = (...a) => e.addTagsFromPaste && e.addTagsFromPaste(...a)),
              onInput: t[6] || (t[6] = (...a) => e.updateNewTag && e.updateNewTag(...a)),
              onFocus: t[7] || (t[7] = (a) => e.focused = !0),
              onClick: t[8] || (t[8] = (a) => e.performClick(a))
            }), null, 16, Se)
          ])
        ]),
        _: 3
      }, 40, ["modelValue", "group", "handle", "item-key", "animation"])), [
        [T, e.onClickOutsideVueTagInput]
      ]) : h("", !0)
    ]),
    v(e.$slots, "between-elements", {}, void 0, !0),
    e.autocompleteOpen ? (g(), p("div", {
      key: 0,
      class: "ti-autocomplete",
      onMouseout: t[12] || (t[12] = (a) => e.selectedItem = null)
    }, [
      v(e.$slots, "autocomplete-header", {}, void 0, !0),
      C("ul", null, [
        (g(!0), p(x, null, ee(e.filteredAutocompleteItems, (a, n) => (g(), p("li", {
          key: n,
          style: M(a.style),
          class: S([[
            a.tiClasses,
            a.classes,
            { "ti-selected-item": e.isSelected(n) }
          ], "ti-item"]),
          onMouseover: (o) => e.disabled ? !1 : e.selectedItem = n
        }, [
          e.$slots["autocomplete-item"] ? v(e.$slots, "autocomplete-item", {
            key: 1,
            item: a,
            index: n,
            performAdd: (o) => e.performAddTags(o, void 0, "autocomplete"),
            selected: e.isSelected(n)
          }, void 0, !0) : (g(), p("div", {
            key: 0,
            onClick: (o) => e.performAddTags(a, void 0, "autocomplete")
          }, R(a.text), 9, Ae))
        ], 46, $e))), 128))
      ]),
      v(e.$slots, "autocomplete-footer", {}, void 0, !0)
    ], 32)) : h("", !0)
  ], 6);
}
const D = /* @__PURE__ */ z(me, [["render", De], ["__scopeId", "data-v-1a9f2556"]]);
D.install = (e) => e.component(D.name, D);
typeof window < "u" && window.Vue && window.Vue.use(D);
export {
  ne as TagInput,
  D as VueTagsInput,
  U as createClasses,
  b as createTag,
  pe as createTags
};
